#include "FrustumCullingTraverser.h"
#include "SceneEntity.h"


namespace CHCDemo
{

FrustumCullingTraverser::FrustumCullingTraverser(): RenderTraverser() 
{
}


void FrustumCullingTraverser::Render()
{
	mRenderState->mTexturesEnabled = false;
	mDistanceQueue.push(mBvh->GetRoot());

	int traversed = 0;
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		// interesting for the visualization, so rest and set
		node->SetVisible(false);
		//mNumTraversedNodes ++;

		//bool intersects;
	
		if (mBvh->IsWithinViewFrustum(node))
		{
			// update node's visited flag => needed for rendering
			// so set it also here
			//node->SetLastVisited(mFrameID);
			//node->SetVisible(true);
			++ traversed;
			TraverseNode(node);
		}
		else
		{
			//mNumFrustumCulledNodes ++;
		}
	}

	std::cout << "traversed: " << traversed << std::endl;
}

}